Index: NEMO/branches/2019/fix_sette_ticket2239/list_avail_rev.sh
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/list_avail_rev.sh	(revision 10715)
+++ 	(revision )
@@ -1,54 +1,0 @@
-#!/bin/bash -f
-# set -vx
-#
-lst_rev () {
-    CFGLST=`ls $1 | sort -u -r ` 
-    CONFIG=$2
-    ALLLST=${@:3}
-    nrevall=`echo $ALLLST | wc -w`
-    nrevcfg=`echo $CFGLST | wc -w`
-    echo ""
-    printf "%-27s : " $CONFIG
-    irev=1
-    irevcfg=1
-    while [[ $irev -le $nrevall ]] ; do
-       rev=`echo $ALLLST | cut -d\  -f ${irev}`
-       #while [[ $irevcfg -le $nrevcfg ]] ; do
-          cfgrev=`echo $CFGLST | cut -d\  -f ${irevcfg}`
-          if [[ $cfgrev -eq $rev ]] ; then
-             printf "%-5s  " $rev
-             irevcfg=$((irevcfg+1))
-          else
-             printf "%-5s  " "*****" 
-          fi
-       #done
-       irev=$((irev+1))
-    done
-}
-
-  . ./param.cfg
-
-  mach=${COMPILER}
-  NEMO_VALID=${NEMO_VALIDATION_DIR}
- 
- # list of all revision available
- DIRLST='';for dir in `find NEMO_VALIDATION -maxdepth 3 -mindepth 3` ; do REV=`basename $dir`; DIRLST="$DIRLST $REV"; done
- DIRLST=`echo $DIRLST | grep -o -E '\w+' | sort -u -r `
-
- # start checking
- echo ""
- printf " List of all avail. rev. is : "
- for dir in `echo $DIRLST`; do printf "%5s  " $dir ; done
- printf "\n"
-# printf "%27s %${nrev}s" "" $DIRLST
- echo ""
- echo "   !---- check revision available for each configuration ----!   "
- for CONFIG in WGYRE_PISCES_ST WORCA2_ICE_PISCES_ST WORCA2_OFF_PISCES_ST WAMM12_ST WORCA2_SAS_ICE_ST WAGRIF_DEMO_ST WSPITZ12_ST WISOMIP_ST WOVERFLOW_ST WLOCK_EXCHANGE_ST WVORTEX_ST WICE_AGRIF_ST 
- do
-    DIR=${NEMO_VALIDATION_DIR}/${CONFIG}/${COMPILER}
-    lst_rev $DIR $CONFIG $DIRLST
- done
- printf "\n"
- printf "\n"
-#
-exit
Index: NEMO/branches/2019/fix_sette_ticket2239/param.cfg
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/param.cfg	(revision 10715)
+++ NEMO/branches/2019/fix_sette_ticket2239/param.cfg	(revision 10717)
@@ -4,12 +4,32 @@
 COMPILER=XC40_METO_perso
 #
+# REFERENCE run.stat tracer.stat you want to compare with
+# (if no change to the default, no check on result change will be done)
+NEMO_VALIDATION_REF=/projects/jomp/pmathiot/NEMO/NEMO_dev/NEMO/trunk/NEMO_VALIDATION
+NEMO_REV_REF=10702
+#
+# IF SETTE_* variable mentioned below are exported from your initialisation, nothing to do
+# otherwise, please update the default iniitialisation or overwrite it
+#
 # BATCH command
 # command to submit a job
-BATCH_CMD=qsub
+BATCH_CMD=${SETTE_BATCH_CMD:-llsubmit}
 # command to check job status
-BATCH_STAT=qstat
+BATCH_STAT=${SETTE_BATCH_STAT:-llq}
+# generic sette job name
+BATCH_NAME=${SETTE_BATCH_NAME:-sette}
 #
 #- FORCING files storing
-FORCING_DIR=/projects/jomp/pmathiot/SETTE_FORCING/v4.0
+FORCING_DIR=${SETTE_FORCING_DIR:-$WORKDIR/FORCING}
+#
+# CMD for svn (some people use git svn) 
+# used in sette_rpt and in all_function to display revision and build correct repository name
+SVN_CMD=${SETTE_SVN_CMD:-svn}
+#
+#- only for IBM
+#TMPDIR=${CONFIG_DIR}/${NEW_CONF}/EXP00
+#
+#- key_nosignedzero
+ADD_NOSIGNEDZERO=${SETTE_ADD_NOSIGNEDZERO:-"yes"}
 #
 #- INPUT files storing
@@ -17,18 +37,4 @@
 #
 #- VALIDATION files storing
-NEMO_VALIDATION_DIR=/projects/jomp/pmathiot/NEMO/NEMO_dev/NEMO/trunk/sette_ticket2239/NEMO_VALIDATION
+NEMO_VALIDATION_DIR=${WORKDIR:-$MAIN_DIR}/NEMO_VALIDATION
 #
-# REFERENCE run.stat tracer.stat you want to compare with
-# (if no change to the default, no check on result change will be done)
-NEMO_VALIDATION_REF=/projects/jomp/pmathiot/NEMO/NEMO_dev/NEMO/trunk/sette/NEMO_VALIDATION
-NEMO_REV_REF=10508
-#
-# CMD for svn (some people use git svn) 
-# used in sette_rpt and in all_function to display revision and build correct repository name
-SVN_CMD=svn
-#
-#- only for IBM
-#TMPDIR=${CONFIG_DIR}/${NEW_CONF}/EXP00
-#
-#- key_nosignedzero
-ADD_NOSIGNEDZERO="yes"
Index: NEMO/branches/2019/fix_sette_ticket2239/sette.sh
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/sette.sh	(revision 10715)
+++ NEMO/branches/2019/fix_sette_ticket2239/sette.sh	(revision 10717)
@@ -1,4 +1,6 @@
 #!/bin/sh
 # initialise user dependent variable
+SETTE_DIR=$(cd $(dirname "$0"); pwd)
+MAIN_DIR=$(dirname $SETTE_DIR)
 . ./param.cfg
 
@@ -39,5 +41,5 @@
       printf "%-3d %s\r" $NRUN 'nemo_sette run still in queue or running ...';
    else
-      printf "%s\n" " "
+      printf "%-50s\n" " "
       ./sette_rpt.sh
       exit
Index: NEMO/branches/2019/fix_sette_ticket2239/sette_list_avail_rev.sh
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/sette_list_avail_rev.sh	(revision 10717)
+++ NEMO/branches/2019/fix_sette_ticket2239/sette_list_avail_rev.sh	(revision 10717)
@@ -0,0 +1,56 @@
+#!/bin/bash -f
+# set -vx
+#
+lst_rev () {
+    CFGLST=`ls $1 | sort -u -r ` 
+    CONFIG=$2
+    ALLLST=${@:3}
+    nrevall=`echo $ALLLST | wc -w`
+    nrevcfg=`echo $CFGLST | wc -w`
+    echo ""
+    printf "%-27s : " $CONFIG
+    irev=1
+    irevcfg=1
+    while [[ $irev -le $nrevall ]] ; do
+       rev=`echo $ALLLST | cut -d\  -f ${irev}`
+       #while [[ $irevcfg -le $nrevcfg ]] ; do
+          cfgrev=`echo $CFGLST | cut -d\  -f ${irevcfg}`
+          if [[ $cfgrev -eq $rev ]] ; then
+             printf "%-5s  " $rev
+             irevcfg=$((irevcfg+1))
+          else
+             printf "%-5s  " "*****" 
+          fi
+       #done
+       irev=$((irev+1))
+    done
+}
+
+  SETTE_DIR=$(cd $(dirname "$0"); pwd)
+  MAIN_DIR=$(dirname $SETTE_DIR)
+  . ./param.cfg
+
+  mach=${COMPILER}
+  NEMO_VALID=${NEMO_VALIDATION_DIR}
+ 
+ # list of all revision available
+ DIRLST='';for dir in `find ${NEMO_VALID} -maxdepth 3 -mindepth 3 -iname [0-9][0-9][0-9][0-9][0-9]` ; do REV=`basename $dir`; DIRLST="$DIRLST $REV"; done
+ DIRLST=`echo $DIRLST | grep -o -E '\w+' | sort -u -r `
+
+ # start checking
+ echo ""
+ printf " List of all avail. rev. is : "
+ for dir in `echo $DIRLST`; do printf "%5s  " $dir ; done
+ printf "\n"
+# printf "%27s %${nrev}s" "" $DIRLST
+ echo ""
+ echo "   !---- check revision available for each configuration ----!   "
+ for CONFIG in WGYRE_PISCES_ST WORCA2_ICE_PISCES_ST WORCA2_OFF_PISCES_ST WAMM12_ST WORCA2_SAS_ICE_ST WAGRIF_DEMO_ST WSPITZ12_ST WISOMIP_ST WOVERFLOW_ST WLOCK_EXCHANGE_ST WVORTEX_ST WICE_AGRIF_ST 
+ do
+    DIR=${NEMO_VALIDATION_DIR}/${CONFIG}/${COMPILER}
+    lst_rev $DIR $CONFIG $DIRLST
+ done
+ printf "\n"
+ printf "\n"
+#
+exit
Index: NEMO/branches/2019/fix_sette_ticket2239/sette_reference-configurations.sh
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/sette_reference-configurations.sh	(revision 10715)
+++ NEMO/branches/2019/fix_sette_ticket2239/sette_reference-configurations.sh	(revision 10717)
@@ -91,4 +91,6 @@
 #
 # LOAD param value
+SETTE_DIR=$(cd $(dirname "$0"); pwd)
+MAIN_DIR=$(dirname $SETTE_DIR)
 . ./param.cfg
 
@@ -132,6 +134,4 @@
 
 # Directory to run the tests
-SETTE_DIR=$(cd $(dirname "$0"); pwd)
-MAIN_DIR=$(dirname $SETTE_DIR)
 CONFIG_DIR0=${MAIN_DIR}/cfgs
 TOOLS_DIR=${MAIN_DIR}/tools
Index: NEMO/branches/2019/fix_sette_ticket2239/sette_rpt.sh
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/sette_rpt.sh	(revision 10715)
+++ NEMO/branches/2019/fix_sette_ticket2239/sette_rpt.sh	(revision 10717)
@@ -504,4 +504,6 @@
 #
 # LOAD param variable (COMPILER, NEMO_VALIDATION_DIR, SVN_CMD)
+  SETTE_DIR=$(cd $(dirname "$0"); pwd)
+  MAIN_DIR=$(dirname $SETTE_DIR)
   . ./param.cfg
 
@@ -517,6 +519,4 @@
 #
 # Directory to run the tests
-  SETTE_DIR=$(cd $(dirname "$0"); pwd)
-  MAIN_DIR=${SETTE_DIR}/..
   CONFIG_DIR0=${MAIN_DIR}/cfgs
   TOOLS_DIR=${MAIN_DIR}/tools
Index: NEMO/branches/2019/fix_sette_ticket2239/sette_test-cases.sh
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/sette_test-cases.sh	(revision 10715)
+++ NEMO/branches/2019/fix_sette_ticket2239/sette_test-cases.sh	(revision 10717)
@@ -93,4 +93,6 @@
 #
 # LOAD param value
+SETTE_DIR=$(cd $(dirname "$0"); pwd)
+MAIN_DIR=$(dirname $SETTE_DIR)
 . ./param.cfg
 
@@ -133,6 +135,4 @@
 
 # Directory to run the tests
-SETTE_DIR=$(cd $(dirname "$0"); pwd)
-MAIN_DIR=$(dirname $SETTE_DIR)
 CONFIG_DIR0=${MAIN_DIR}/cfgs
 TOOLS_DIR=${MAIN_DIR}/tools