Index: /NEMO/branches/2019/fix_sette_ticket2239/param.cfg
===================================================================
--- /NEMO/branches/2019/fix_sette_ticket2239/param.cfg	(revision 10746)
+++ /NEMO/branches/2019/fix_sette_ticket2239/param.cfg	(revision 10747)
@@ -19,4 +19,6 @@
 # generic sette job name
 BATCH_NAME=${SETTE_BATCH_NAME:-sette}
+# List of test configurations
+TEST_CONFIGS=${SETTE_TEST_CONFIGS:-"GYRE_PISCES ORCA2_ICE_PISCES ORCA2_OFF_PISCES AMM12 SAS ORCA2_ICE_OBS AGRIF SPITZ12 LOCK_EXCHANGE VORTEX ICE_AGRIF ISOMIP"}
 #
 #- FORCING files storing
Index: /NEMO/branches/2019/fix_sette_ticket2239/sette.sh
===================================================================
--- /NEMO/branches/2019/fix_sette_ticket2239/sette.sh	(revision 10746)
+++ /NEMO/branches/2019/fix_sette_ticket2239/sette.sh	(revision 10747)
@@ -3,4 +3,13 @@
 SETTE_DIR=$(cd $(dirname "$0"); pwd)
 MAIN_DIR=$(dirname $SETTE_DIR)
+
+# Parse command-line arguments
+#
+#  -t "test configurations": select active test configurations
+#                            (overrides selection made using
+#                            environment variable SETTE_TEST_CONFIGS)
+while getopts t: option; do [ $option == "t" ] && export SETTE_TEST_CONFIGS=$OPTARG; done
+shift $((OPTIND - 1))
+
 . ./param.cfg
 
Index: /NEMO/branches/2019/fix_sette_ticket2239/sette_reference-configurations.sh
===================================================================
--- /NEMO/branches/2019/fix_sette_ticket2239/sette_reference-configurations.sh	(revision 10746)
+++ /NEMO/branches/2019/fix_sette_ticket2239/sette_reference-configurations.sh	(revision 10747)
@@ -141,16 +141,16 @@
 cd ${SETTE_DIR}
 cp BATCH_TEMPLATE/${JOB_PREFIX}-${COMPILER} job_batch_template || exit
-# Description of configuration tested:
-# GYRE_PISCES       :  1 
-# ORCA2_ICE_PISCES  :  2 
-# ORCA2_OFF_PISCES  :  3 
-# AMM12             :  4 
-# SAS               :  5
-# ORCA2_ICE_OBS     :  6
-# AGRIF             :  7 & 8  test AGRIF in a double zoom configuration in the nordic seas + 1 zoom in the eq. Pacific (AGRIF_DEMO)
-#                               and check that key_agrif without zoom = no key_agrif
-# SPITZ12           :  9      regional configuration including sea-ice and tides (Spitzbergen)
-
-for config in 1 2 3 4 5 6 7 8 9
+# Description of available configurations:
+# GYRE_PISCES       :
+# ORCA2_ICE_PISCES  :
+# ORCA2_OFF_PISCES  :
+# AMM12             :
+# SAS               :
+# ORCA2_ICE_OBS     :
+# AGRIF             : test AGRIF in a double zoom configuration in the nordic seas + 1 zoom in the eq. Pacific (AGRIF_DEMO)
+#                       and check that key_agrif without zoom = no key_agrif
+# SPITZ12           : regional configuration including sea-ice and tides (Spitzbergen)
+
+for config in ${TEST_CONFIGS}
 do
 
@@ -158,5 +158,5 @@
 # GYRE_PISCES
 # -----------
-if [ ${config} -eq 1 ] ;  then
+if [ ${config} == "GYRE_PISCES" ] ;  then
 ## Restartability tests for GYRE_PISCES
     export TEST_NAME="LONG"
@@ -294,5 +294,5 @@
 # ORCA2_ICE_PISCES
 # -----------------
-if [ ${config} -eq 2 ] ;  then
+if [ ${config} == "ORCA2_ICE_PISCES" ] ;  then
 ## Restartability tests for ORCA2_ICE_PISCES
     export TEST_NAME="LONG"
@@ -531,5 +531,5 @@
 # ORCA2_OFF_PISCES
 # ----------------
-if [ ${config} -eq 3 ] ;  then
+if [ ${config} == "ORCA2_OFF_PISCES" ] ;  then
 ## Restartability tests for ORCA2_OFF_PISCES
     export TEST_NAME="LONG"
@@ -717,5 +717,5 @@
 # AMM12
 # -----
-if [ ${config} -eq 4 ] ;  then
+if [ ${config} == "AMM12" ] ;  then
     ## Restartability tests for AMM12
     export TEST_NAME="LONG"
@@ -840,5 +840,5 @@
 # ORCA2_SAS
 # ---------
-if [ ${config} -eq 5 ] ;  then
+if [ ${config} == "SAS" ] ;  then
 ## Restartability tests
     export TEST_NAME="LONG"
@@ -970,5 +970,5 @@
 ## Test assimilation interface code, OBS and ASM for reproducibility
 ## Restartability not tested (ASM code not restartable while increments are being applied)
-if [ ${config} -eq 6 ] ; then
+if [ ${config} == "ORCA2_ICE_OBS" ] ; then
 ## Reproducibility tests
     export TEST_NAME="REPRO_4_8"
@@ -1086,5 +1086,5 @@
 # AGRIF ICE
 # -----------
-if [ ${config} -eq 7 ] ;  then
+if [ ${config} == "AGRIF" ] ;  then
 ## Restartability tests
     export TEST_NAME="LONG"
@@ -1351,5 +1351,5 @@
 
 ## test code corruption with AGRIF (phase 2) ==> Compile without key_agrif (to be compared with AGRIF_DEMO_ST/ORCA2)
-if [ ${config} -eq 8 ] ;  then
+if [ ${config} == "AGRIF" ] ;  then
     export TEST_NAME="ORCA2"
     cd ${MAIN_DIR}
@@ -1386,5 +1386,5 @@
 # SPITZ12
 # -------
-if [ ${config} -eq 9 ] ;  then
+if [ ${config} == "SPITZ12" ] ;  then
 ## Restartability tests
     export TEST_NAME="LONG"
Index: /NEMO/branches/2019/fix_sette_ticket2239/sette_test-cases.sh
===================================================================
--- /NEMO/branches/2019/fix_sette_ticket2239/sette_test-cases.sh	(revision 10746)
+++ /NEMO/branches/2019/fix_sette_ticket2239/sette_test-cases.sh	(revision 10747)
@@ -143,16 +143,16 @@
 cp BATCH_TEMPLATE/${JOB_PREFIX}-${COMPILER} job_batch_template || exit
 # Description of configuration tested:
-# OVERFLOW       : 1  TEST s-coordinates : (tracers) Advection schemes: FCT2, FCT4, ubs 
-#                                        & (dynamics) advection schemes: flux form (ubs, centered), vector form (een)
-#                          zps-coordinates : (tracers) Advection schemes: FCT2, FCT4, ubs
-#                                        & (dynamics) advection schemes: flux form (ubs, centered), vector form (een, and een + Hollingsworth correction)
-# LOCK_EXCHANGE  : 2
-# VORTEX         : 3
-# ICE_AGRIF      : 4
-# ISOMIP         : 5
+# OVERFLOW       : TEST s-coordinates : (tracers) Advection schemes: FCT2, FCT4, ubs 
+#                                     & (dynamics) advection schemes: flux form (ubs, centered), vector form (een)
+#                       zps-coordinates : (tracers) Advection schemes: FCT2, FCT4, ubs
+#                                     & (dynamics) advection schemes: flux form (ubs, centered), vector form (een, and een + Hollingsworth correction)
+# LOCK_EXCHANGE  : 
+# VORTEX         : 
+# ICE_AGRIF      : 
+# ISOMIP         : 
 # WAD
 
 
-for config in 1 2 3 4 5 
+for config in ${TEST_CONFIGS}
 do
 
@@ -160,5 +160,5 @@
 #  OVERFLOW
 # ---------
-if [ ${config} -eq 1 ] ;  then
+if [ ${config} == "OVERFLOW" ] ;  then
     ## Restartability tests for OVERFLOW
     export TEST_NAME="LONG"
@@ -254,5 +254,5 @@
 #  LOCK_EXCHANGE
 # --------------
-if [ ${config} -eq 2 ] ;  then
+if [ ${config} == "LOCK_EXCHANGE" ] ;  then
     ## Restartability tests for LOCK_EXCHANGE
     export TEST_NAME="LONG"
@@ -349,5 +349,5 @@
 # VORTEX
 # ---------
-if [ ${config} -eq 3 ] ;  then 
+if [ ${config} == "VORTEX" ] ;  then 
 ## Restartability tests for VORTEX
     export TEST_NAME="LONG"
@@ -522,5 +522,5 @@
 # ICE_AGRIF
 # ---------
-if [ ${config} -eq 4 ] ;  then 
+if [ ${config} == "ICE_AGRIF" ] ;  then 
 ## Restartability tests for ICE_AGRIF
     export TEST_NAME="LONG"
@@ -703,5 +703,5 @@
 # ISOMIP
 # ------
-if [ ${config} -eq 5 ] ;  then
+if [ ${config} == "ISOMIP" ] ;  then
 ## Restartability tests
     export TEST_NAME="LONG"