Index: NEMO/branches/2019/fix_sette_ticket2239/README
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/README	(revision 10749)
+++ NEMO/branches/2019/fix_sette_ticket2239/README	(revision 10750)
@@ -2,11 +2,15 @@
 
 PRINCIPAL SCRIPT: sette.sh 
-sette.sh is a simple wrapper running test on the reference configuration, test cases and generate the report at the end.
-User need to set up the param.cfg file correctly and download input file before running the script.
+ * sette.sh is a simple wrapper running test on the reference configuration, test cases and generate the report at the end.
+ * sette.sh is able to take a list of configuration in argument (sette.sh -t "CFG1 CFG2 CFG3"). The list of available configurations is available in running ./sette_list_avail_cfg.sh.
+   The default for sette is to run all of the reference and test configurations.
+ * User need to set up the param.cfg file correctly and download input file before running the script.
 
 SECONDARY SCRIPT
-sette_reference-configuration.sh, sette_test-cases.sh: run sette tests on the reference configurations and test cases respectively
-sette_rpt.sh: generate the sette report. See below in USER MODIFICATIONS the usage of the script
-sette_list_avail_rev.sh: generate a listing on all the revision available in the validation directory for each configuration.
+ * sette_reference-configuration.sh: run sette tests on the reference configurations
+ * sette_test-cases.sh             : run sette tests on test cases
+ * sette_rpt.sh                    : generate the sette report. See below in USER MODIFICATIONS the usage of the script
+ * sette_list_avail_rev.sh         : generate a listing on all the revision available in the validation directory for each configuration.
+ * sette_list_avail_cfg.sh         : generate a listing of all the available configurations.
 
 VERY IMPORTANT : for a verbose debug do:
@@ -15,5 +19,5 @@
 
 USER MODIFICATIONS
- in sette_cfg-ref.sh and sette_test-cases.sh script :
+ * in sette_cfg-ref.sh and sette_test-cases.sh script :
                OPTIONAL ARGUMENT : compiler among those available in NEMOGCM/ARCH (if nothing will use the one specified in paramd.cfg)
 	       BATCH_COMMAND_PAR : command for job submission in batch mode parallel (MMIÂ) specified in param.cfg
@@ -48,5 +52,5 @@
 			and only run short test ===> ./fcm_job 4 SHORT no    yes   )
 
- in param.cfg :
+ * in param.cfg :
                
                COMPILER    : compiler among those available in NEMOGCM/ARCH
@@ -64,5 +68,5 @@
                ADD_NODIGNEDZERO    : set "yes" if you need key_nosignedzero to run nemo
 
- in fcm_job.sh :
+ * in fcm_job.sh :
                IMPORTANT : control that name of tar file in FORCING directory
                is the same of that in input_REF_CONFIG.cfg, if not change one.
@@ -71,5 +75,5 @@
 	       NOTE: if INTERACT_FLAG="no" it is needed a batch_file (see below to create a new one)
 
- in sette_rpt.sh : - if no argument are given, the report will be generated on the last changed revision.
+ * in sette_rpt.sh : - if no argument are given, the report will be generated on the last changed revision.
                    - if an argument is given (revision number) the report will be generated for this revision
                    - if 'old' is given as argument the former behavior is applied (the latest revision is check whatever the current revision
@@ -97,7 +101,8 @@
 1. add arch-compiler.fcm in NEMOGCM/ARCH directory
 2. makenemo -m new_compiler  (see makenemo -h for help)
+3. add new batch-file
 
 TO ADD NEW BATCH-FILE:
 1. see in SETTE/BATCH_TEMPLATE directory existing examples
 2. create you own batch file like: batch-${COMPILER}
-(note: sette_test-cases.sh and sette_cfg-ref.sh will copy it in job_batch_template if you run tests in INTERACT_FLAG="no")
+   (note: sette_test-cases.sh and sette_cfg-ref.sh will copy it in job_batch_template if you run tests in INTERACT_FLAG="no")
Index: NEMO/branches/2019/fix_sette_ticket2239/param.cfg
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/param.cfg	(revision 10749)
+++ NEMO/branches/2019/fix_sette_ticket2239/param.cfg	(revision 10750)
@@ -2,5 +2,5 @@
 #
 # Compiler among those in NEMOGCM/ARCH
-COMPILER=X64_ADA
+COMPILER=XC40_METO_perso
 #
 # REFERENCE run.stat tracer.stat you want to compare with
@@ -20,5 +20,5 @@
 BATCH_NAME=${SETTE_BATCH_NAME:-sette}
 # List of test configurations
-TEST_CONFIGS=${SETTE_TEST_CONFIGS:-"GYRE_PISCES ORCA2_ICE_PISCES ORCA2_OFF_PISCES AMM12 SAS ORCA2_ICE_OBS AGRIF SPITZ12 LOCK_EXCHANGE VORTEX ICE_AGRIF ISOMIP"}
+TEST_CONFIGS=${SETTE_TEST_CONFIGS:-"GYRE_PISCES ORCA2_ICE_PISCES ORCA2_OFF_PISCES AMM12 SAS ORCA2_ICE_OBS AGRIF SPITZ12 OVERFLOW LOCK_EXCHANGE VORTEX ICE_AGRIF ISOMIP"}
 #
 #- FORCING files storing
Index: NEMO/branches/2019/fix_sette_ticket2239/sette.sh
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/sette.sh	(revision 10749)
+++ NEMO/branches/2019/fix_sette_ticket2239/sette.sh	(revision 10750)
@@ -9,6 +9,14 @@
 #                            (overrides selection made using
 #                            environment variable SETTE_TEST_CONFIGS)
-while getopts t: option; do [ $option == "t" ] && export SETTE_TEST_CONFIGS=$OPTARG; done
-shift $((OPTIND - 1))
+
+if [ $# -gt 0 ]; then
+  while getopts t: option; do 
+     case $option in
+        t) export SETTE_TEST_CONFIGS=$OPTARG ;;
+        h) echo 'sette.sh allow no arguments (all configuration will be tested or -t "CFG1_to_test CFG2_to_test ..."'; exit 42 ;;
+     esac
+  done
+  shift $((OPTIND - 1))
+fi
 
 . ./param.cfg
Index: NEMO/branches/2019/fix_sette_ticket2239/sette_reference-configurations.sh
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/sette_reference-configurations.sh	(revision 10749)
+++ NEMO/branches/2019/fix_sette_ticket2239/sette_reference-configurations.sh	(revision 10750)
@@ -310,6 +310,6 @@
     set_namelist namelist_cfg cn_exp \"O2L3P_LONG\"
     set_namelist namelist_cfg nn_it000 1
-    set_namelist namelist_cfg nn_itend 990
-    set_namelist namelist_cfg nn_stock 495
+    set_namelist namelist_cfg nn_itend 992
+    set_namelist namelist_cfg nn_stock 496
     set_namelist namelist_cfg jpni 4
     set_namelist namelist_cfg jpnj 8
@@ -358,7 +358,7 @@
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"O2L3P_SHORT\"
-    set_namelist namelist_cfg nn_it000 496
-    set_namelist namelist_cfg nn_itend 990
-    set_namelist namelist_cfg nn_stock 495
+    set_namelist namelist_cfg nn_it000 497
+    set_namelist namelist_cfg nn_itend 992
+    set_namelist namelist_cfg nn_stock 496
     set_namelist namelist_cfg ln_rstart .true.
     set_namelist namelist_cfg nn_rstctl 2
@@ -383,7 +383,7 @@
     set_namelist namelist_top_cfg ln_rsttr .true.
     set_namelist namelist_top_cfg nn_rsttr 2
-    set_namelist namelist_cfg cn_ocerst_in \"O2L3P_LONG_00000495_restart\"
-    set_namelist namelist_top_cfg cn_trcrst_in \"O2L3P_LONG_00000495_restart_trc\"
-    set_namelist namelist_ice_cfg cn_icerst_in \"O2L3P_LONG_00000495_restart_ice\"
+    set_namelist namelist_cfg cn_ocerst_in \"O2L3P_LONG_00000496_restart\"
+    set_namelist namelist_top_cfg cn_trcrst_in \"O2L3P_LONG_00000496_restart_trc\"
+    set_namelist namelist_ice_cfg cn_icerst_in \"O2L3P_LONG_00000496_restart_ice\"
     set_namelist namelist_top_cfg ln_trcdta .false.
     # put ln_ironsed, ln_river, ln_ndepo, ln_dust
@@ -403,10 +403,10 @@
         L_NPROC=$(( $i - 1 ))
         L_NPROC=`printf "%04d\n" ${L_NPROC}`
-        ln -sf ../LONG/O2L3P_LONG_00000495_restart_${L_NPROC}.nc .
-        ln -sf ../LONG/O2L3P_LONG_00000495_restart_trc_${L_NPROC}.nc .
-        ln -sf ../LONG/O2L3P_LONG_00000495_restart_ice_${L_NPROC}.nc .
+        ln -sf ../LONG/O2L3P_LONG_00000496_restart_${L_NPROC}.nc .
+        ln -sf ../LONG/O2L3P_LONG_00000496_restart_trc_${L_NPROC}.nc .
+        ln -sf ../LONG/O2L3P_LONG_00000496_restart_ice_${L_NPROC}.nc .
         if [ ${USING_ICEBERGS} == "yes" ]
             then
-             ln -sf ../LONG/O2L3P_LONG_icebergs_00000495_restart_${L_NPROC}.nc O2L3P_LONG_00000495_restart_icebergs_${L_NPROC}.nc
+             ln -sf ../LONG/O2L3P_LONG_icebergs_00000496_restart_${L_NPROC}.nc O2L3P_LONG_00000496_restart_icebergs_${L_NPROC}.nc
         fi
     done
@@ -435,5 +435,5 @@
     set_namelist namelist_cfg cn_exp \"O2L3P_48\"
     set_namelist namelist_cfg nn_it000 1
-    set_namelist namelist_cfg nn_itend 990
+    set_namelist namelist_cfg nn_itend 992
     set_namelist namelist_cfg jpni 4
     set_namelist namelist_cfg jpnj 8
@@ -486,5 +486,5 @@
     set_namelist namelist_cfg cn_exp \"O2L3P_84\"
     set_namelist namelist_cfg nn_it000 1
-    set_namelist namelist_cfg nn_itend 990
+    set_namelist namelist_cfg nn_itend 992
     set_namelist namelist_cfg jpni 8
     set_namelist namelist_cfg jpnj 4
@@ -856,6 +856,6 @@
     set_namelist namelist_cfg cn_exp \"SAS\"
     set_namelist namelist_cfg nn_it000 1
-    set_namelist namelist_cfg nn_itend 240
-    set_namelist namelist_cfg nn_stock 120
+    set_namelist namelist_cfg nn_itend 256
+    set_namelist namelist_cfg nn_stock 128
     set_namelist namelist_cfg jpni 4
     set_namelist namelist_cfg jpnj 8
@@ -878,6 +878,6 @@
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"SAS\"
-    set_namelist namelist_cfg nn_it000 121
-    set_namelist namelist_cfg nn_itend 240
+    set_namelist namelist_cfg nn_it000 129
+    set_namelist namelist_cfg nn_itend 256
     set_namelist namelist_cfg jpni 4
     set_namelist namelist_cfg jpnj 8
@@ -888,6 +888,6 @@
     set_namelist namelist_cfg nn_rstctl 2
     set_namelist namelist_cfg nn_date0 010109
-    set_namelist namelist_cfg cn_ocerst_in \"SAS_00000120_restart\"
-    set_namelist namelist_ice_cfg cn_icerst_in \"SAS_00000120_restart_ice\"
+    set_namelist namelist_cfg cn_ocerst_in \"SAS_00000128_restart\"
+    set_namelist namelist_ice_cfg cn_icerst_in \"SAS_00000128_restart_ice\"
     if [ ${USING_MPMD} == "yes" ] ; then
        set_xio_using_server iodef.xml true
@@ -898,6 +898,6 @@
         L_NPROC=$(( $i - 1 ))
         L_NPROC=`printf "%04d\n" ${L_NPROC}`
-        ln -sf ../LONG/SAS_00000120_restart_${L_NPROC}.nc .
-        ln -sf ../LONG/SAS_00000120_restart_ice_${L_NPROC}.nc .
+        ln -sf ../LONG/SAS_00000128_restart_${L_NPROC}.nc .
+        ln -sf ../LONG/SAS_00000128_restart_ice_${L_NPROC}.nc .
     done
     cd ${SETTE_DIR}
@@ -920,5 +920,5 @@
     set_namelist namelist_cfg cn_exp \"SAS_48\"
     set_namelist namelist_cfg nn_it000 1
-    set_namelist namelist_cfg nn_itend 75
+    set_namelist namelist_cfg nn_itend 80
     set_namelist namelist_cfg jpni 4
     set_namelist namelist_cfg jpnj 8
@@ -946,5 +946,5 @@
     set_namelist namelist_cfg cn_exp \"SAS_84\"
     set_namelist namelist_cfg nn_it000 1
-    set_namelist namelist_cfg nn_itend 75
+    set_namelist namelist_cfg nn_itend 80
     set_namelist namelist_cfg jpni 8
     set_namelist namelist_cfg jpnj 4
@@ -986,5 +986,5 @@
     set_namelist namelist_cfg cn_exp \"O2L3OBS_48\"
     set_namelist namelist_cfg nn_it000 1
-    set_namelist namelist_cfg nn_itend 75
+    set_namelist namelist_cfg nn_itend 80
     set_namelist namelist_cfg ln_read_cfg .true.
     set_namelist namelist_cfg jpni 4
@@ -1039,5 +1039,5 @@
     set_namelist namelist_cfg cn_exp \"O2L3OBS_84\"
     set_namelist namelist_cfg nn_it000 1
-    set_namelist namelist_cfg nn_itend 75
+    set_namelist namelist_cfg nn_itend 80
     set_namelist namelist_cfg ln_read_cfg .true.
     set_namelist namelist_cfg jpni 8